/**
  *  \file client/dlg-comment.cc
  *
  *  (c) 2001-2011 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "client/dlg-comment.h"
#include "int/data.h"
#include "int/intglobal.h"
#include "ui/widgets.h"
#include "game/obj.h"
#include "game/global.h"

void
doEditComment(GObject& obj, IntDataSegment& data, string_t prompt, string_t title)
{
    // Fetch current comment
    string_t comment;
    if (IntValue* iv = data[pp_Comment])
        comment = iv->toString(false);

    // Standard dialog
    if (UIInputLine::run(comment, 255 /* FIXME: should we raise this? */, title, prompt, 30, UIInputLine::ilf_GameChars /* FIXME: can we support UTF-8? */)) {
        comment = strRTrim(comment);
        if (comment.size())
            data.set(pp_Comment, makeStringValue(comment));
        else
            data.set(pp_Comment, 0);

        obj.markDirty();
        getDisplayedTurn().getCurrentUniverse().doScreenUpdates();
    }
}
